import { jsx as _jsx, Fragment as _Fragment } from "react/jsx-runtime";
import { memo } from 'react';
import { getEnv } from '@brushes/api';
import { config } from './config';
import { useEditAddress } from './hooks';
import { useComponent, antdMobile } from '@brushes/qj-simulate-component';
import { Skull } from './components/skull';
const flag = getEnv();
const AddressDetailJsx = ({ addressId = undefined }) => {
    const { View } = useComponent();
    const { Form, Button, Input } = antdMobile;
    const { skullShow, form, area, defaultAddress, handleArea, handleDefaultAddress, handleFinish } = useEditAddress(addressId, Form);
    return (_jsx(View, Object.assign({ className: 'addressDetail', style: { height: flag ? '100%' : '667px' } }, { children: skullShow ? (_jsx(Skull, {})) : (_jsx(Form, Object.assign({ form: form, layout: "horizontal", mode: "card", onFinish: handleFinish, footer: _jsx(Button, Object.assign({ block: true, type: "submit", color: "primary", size: "large" }, { children: "\u63D0\u4EA4" })) }, { children: config.map((item, index) => {
                return (_jsx(Form.Item, Object.assign({ label: item.label, name: item.name, rules: item.rules, trigger: item.type === 'cascader' ? 'onConfirm' : 'onChange', arrow: false }, { children: (() => {
                        if (item.type === 'input') {
                            return _jsx(Input, Object.assign({}, item.props));
                        }
                        else if (item.type === 'switch') {
                            return (_jsx("switch", Object.assign({}, item.props, { color: '#000', onChange: handleDefaultAddress, checked: defaultAddress === '1' })));
                        }
                        else if (item.type === 'cascader') {
                            return (_jsx(_Fragment, { children: flag ? (_jsx("picker", Object.assign({ mode: 'region', onChange: handleArea, value: '123' }, { children: _jsx(View, Object.assign({ className: 'areaWrap' }, { children: !area.provinceName
                                            ? '请选择所在地区'
                                            : `${area.provinceName}—${area.cityName}-${area.areaName}` })) }))) : ('请选择所在地区') }));
                        }
                    })() }), index));
            }) }))) })));
};
export const AddressDetail = memo(AddressDetailJsx);
