var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import { useEffect, useState } from 'react';
import { deleteAddress, queryAddressBymerberCode, updateAddress } from '@brushes/api';
export function useAddressList() {
    const [list, setList] = useState([]);
    const [skullShow, setSkullShow] = useState(true);
    useEffect(() => {
        getAddressList();
    }, []);
    const getAddressList = () => __awaiter(this, void 0, void 0, function* () {
        const resList = yield queryAddressBymerberCode();
        setList(resList);
        setSkullShow(false);
    });
    const delAddress = (addressInfo) => {
        wx === null || wx === void 0 ? void 0 : wx.showModal({
            title: '提示',
            content: '确认删除该地址吗？',
            success: (res) => __awaiter(this, void 0, void 0, function* () {
                if (res === null || res === void 0 ? void 0 : res.confirm) {
                    yield deleteAddress({ addressId: addressInfo.addressId });
                    yield getAddressList();
                }
            })
        });
    };
    const setDefault = (addressInfo, index) => __awaiter(this, void 0, void 0, function* () {
        if (addressInfo.addressDefault !== '1') {
            const { addressMember, addressPhone, provinceCode, provinceName, cityCode, cityName, areaCode, areaName, addressDetail, addressId, addressCode, dataState } = addressInfo;
            const params = {
                addressMember,
                addressPhone,
                provinceCode,
                provinceName,
                cityCode,
                cityName,
                areaCode,
                areaName,
                addressDetail,
                addressId,
                addressCode,
                dataState,
                addressDefault: '1'
            };
            setList(replaceArr(index, list));
            yield updateAddress(params);
            yield getAddressList();
        }
    });
    const replaceArr = (coe, arr) => {
        const chooseItem = arr[coe];
        console.log(chooseItem);
        arr[coe] = arr[0];
        arr[coe].addressDefault = '0';
        arr[0] = chooseItem;
        arr[0].addressDefault = '1';
        console.log(111111, arr);
        return [...arr];
    };
    return {
        list,
        skullShow,
        delAddress,
        setDefault
    };
}
