var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import { useEffect, useMemo, useState, useRef } from 'react';
import { queryShoppingPage } from '@brushes/api';
import { _ } from '@brushes/tools';
import { useDispatchImpl, useStore } from '../store';
import { updateShoppingGoodsNum } from '../../../utils/payment';
import { navigatorImpl } from '../../../../../../../qj-mobile-core/packages/qj-simulate-component';
import { routerMap } from '../../../routerMap';
const { get } = _;
export function useCartList() {
    const dispatch = useDispatchImpl();
    const { select } = useStore();
    const allCart = useRef([]);
    const [cartList, setCartList] = useState({
        shoppingGoodsList: [],
        disMoney: 0
    });
    useEffect(() => {
        (() => __awaiter(this, void 0, void 0, function* () {
            yield initImpl('isFirst');
        }))();
    }, []);
    const updateImpl = (id, count) => __awaiter(this, void 0, void 0, function* () {
        try {
            yield updateShoppingGoodsNum({
                shoppingGoodsId: id,
                amount: count,
                goodWeight: 0
            });
            yield initImpl();
        }
        catch (err) {
            console.log(err);
        }
    });
    const initImpl = (isFirst = '') => __awaiter(this, void 0, void 0, function* () {
        const data = yield queryShoppingPage();
        const cart = get(data, 'rows[0].shoppingpackageList[0]', {
            shoppingGoodsList: [],
            // sumMoney: 0,
            disMoney: 0
        });
        allCart.current = cart.shoppingGoodsList.map((item) => item.shoppingGoodsId + '');
        if (isFirst) {
            dispatch({
                type: 'select',
                payload: allCart.current
            });
        }
        setCartList(cart);
    });
    const amount = useMemo(() => {
        let num = 0, amount = 0;
        cartList.shoppingGoodsList.forEach((item) => {
            if (select.includes(item.shoppingGoodsId + '')) {
                num += item.goodsCamount;
                amount += item.goodsCamount * item.pricesetNprice;
            }
        });
        return {
            num,
            amount
        };
    }, [select, cartList]);
    const selectAll = (e) => {
        dispatch({
            type: 'select',
            payload: e.detail.value.includes('true') ? allCart.current : []
        });
    };
    const toOrderImpl = () => {
        navigatorImpl(`${routerMap.confirm}?shoppingGoodsId=${select.join(',')}`);
    };
    return {
        cartList,
        amount,
        selectAll,
        allCart,
        updateImpl,
        toOrderImpl
    };
}
