var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import { useDispatchImpl, useStore } from '../store';
import { _ } from '@brushes/tools';
import { checkSkuSpec, addCardSku } from '../../../utils/payment';
import { navigatorImpl } from '@brushes/qj-simulate-component';
import { routerMap } from '../../../routerMap';
const { get } = _;
export function useAddShopping() {
    const { count, spec, orderType, popupVisible, isNeedButton, goodsCode } = useStore();
    const dispatch = useDispatchImpl();
    const handleChooseSize = (value) => {
        dispatch({
            type: 'select',
            payload: {
                spec: value
            }
        });
    };
    const popupHandler = () => {
        dispatch({
            type: 'popupImpl',
            payload: {
                popupVisible: !popupVisible
            }
        });
    };
    const handleStep = (type) => {
        dispatch({
            type
        });
    };
    const addCardImpl = () => __awaiter(this, void 0, void 0, function* () {
        try {
            const data = yield checkSkuSpec(spec, goodsCode);
            const skuId = get(data, 'dataObj.skuId');
            yield addCardSku(skuId, count);
            popupHandler();
        }
        catch (err) { }
    });
    const cashImpl = () => __awaiter(this, void 0, void 0, function* () {
        const data = yield checkSkuSpec(spec, goodsCode);
        const skuId = get(data, 'dataObj.skuId');
        navigatorImpl(`${routerMap.confirm}?skuId=${skuId}&goodsNum=${count}`);
    });
    const addShoppingImpl = () => {
        if (orderType === 0) {
            // 添加到购物车
            addCardImpl();
        }
        else {
            // 去支付页面
            cashImpl();
        }
    };
    return {
        count,
        spec,
        popupVisible,
        isNeedButton,
        handleChooseSize,
        handleStep,
        addShoppingImpl,
        popupHandler
    };
}
