import { jsx as _jsx, jsxs as _jsxs, Fragment as _Fragment } from "react/jsx-runtime";
import { memo } from 'react';
import { _ } from '@brushes/tools';
import GoodsDetailPromotion from './components/goodsDetailPromotion';
import GoodsDetailCoupon from './components/goodsDetailCoupon';
import GoodsDetailCollection from './components/goodsDetailCollection';
import GoodsDetailHandleBar from './components/goodsDetailHandleBar';
import { Slider } from '../Slider';
import GoodsDetailInfo from './components/goodsDetailInfo';
import GoodsDetailEvaluate from './components/goodsDetailEvaluate';
import GoodsDetailSize from './components/goodsDetailSize';
import { useGoodsDetailImpl } from './hooks';
import { StoreProvider } from './store';
import { getEnv } from '@brushes/api';
import { useComponent } from '@brushes/qj-simulate-component';
const { isEmpty } = _;
const flag = getEnv();
const GoodsDetailJsx = ({ skuCode }) => {
    return (_jsx(StoreProvider, { children: _jsx(GoodsDetailJsxInner, { skuCode: skuCode }) }));
};
const GoodsDetailJsxInner = ({ skuCode }) => {
    var _a;
    const { View, Text, Skeleton } = useComponent();
    const { goods, promotionArr, checkCollectionObj, setCheckCollectionObj, sliderArr, tabActive, setTabActive } = useGoodsDetailImpl(skuCode);
    return (_jsx(View, Object.assign({ className: 'GoodsDetailWrap', style: {
            minHeight: flag ? '' : '667px',
            height: flag ? '' : 'auto',
            overflow: flag ? '' : 'auto'
        } }, { children: isEmpty(goods) ? (_jsxs(View, Object.assign({ className: 'skeleton' }, { children: [_jsx(Skeleton, { animated: true, style: {
                        '--width': '100%',
                        '--height': '300px'
                    } }), _jsx(Skeleton.Title, { animated: true }), _jsx(Skeleton.Paragraph, { lineCount: 10, animated: true })] }))) : (_jsxs(_Fragment, { children: [_jsx(View, Object.assign({ className: 'topSlider' }, { children: _jsx(Slider, { selectImg: sliderArr, type: 1, imgHeight: { height: 375, width: 375 } }) })), _jsxs(View, Object.assign({ className: 'goodsDetail-topInfo' }, { children: [_jsxs(View, { children: [_jsx(Text, Object.assign({ className: 'name' }, { children: goods === null || goods === void 0 ? void 0 : goods.goodsName })), _jsxs(Text, Object.assign({ className: 'price' }, { children: ["\uFFE5", (_a = goods === null || goods === void 0 ? void 0 : goods.pricesetNprice) === null || _a === void 0 ? void 0 : _a.toFixed(2)] }))] }), _jsx(View, Object.assign({ className: 'rPart' }, { children: _jsx(GoodsDetailCollection, { goods: goods, checkCollectionObj: checkCollectionObj, setCheckCollectionObj: setCheckCollectionObj }) }))] })), _jsx(GoodsDetailSize, { goods: goods }), _jsx(GoodsDetailPromotion, { promotionList: promotionArr }), _jsx(GoodsDetailCoupon, {}), _jsxs(View, Object.assign({ className: 'goodsDetailTab' }, { children: [_jsxs(View, Object.assign({ className: 'tabs' }, { children: [_jsxs(Text, Object.assign({ className: `tabsItem ${tabActive === 1 ? 'active' : ''}`, onClick: () => setTabActive(1) }, { children: ["\u5546\u54C1\u8BE6\u60C5", _jsx(Text, { className: 'line' })] })), _jsxs(Text, Object.assign({ className: `tabsItem ${tabActive === 2 ? 'active' : ''}`, onClick: () => setTabActive(2) }, { children: ["\u8BC4\u4EF7", _jsx(Text, { className: 'line' })] }))] })), _jsx(View, Object.assign({ className: 'group' }, { children: tabActive === 1 ? (_jsx(GoodsDetailInfo, { tabActive: tabActive, goods: goods })) : (_jsx(GoodsDetailEvaluate, {})) }))] })), _jsx(GoodsDetailHandleBar, {})] })) })));
};
export const GoodsDetail = memo(GoodsDetailJsx);
