import { makeStore } from 'qj-mobile-store';
const defaultValues = {
    count: 1,
    orderType: 0,
    isNeedButton: false,
    popupVisible: false,
    goodsNum: 1,
    goodsCode: ''
};
function reduceImpl(state, action) {
    switch (action.type) {
        case 'plus':
            return Object.assign(Object.assign({}, state), { count: state.count + 1 });
        case 'minus':
            return Object.assign(Object.assign({}, state), { count: state.count - 1 });
        case 'select':
        case 'initGoods':
        case 'popupImpl':
            return Object.assign(Object.assign({}, state), action.payload);
        default:
            return state;
    }
}
/**
 * =========== StoreProvider, useStore, useDispatchImpl ============
 * 导出三个参数
 * 第一个是Provider
 * 第二个是Store
 * 第三个是Dispath
 *
 */
const [StoreProvider, useStore, useDispatchImpl] = makeStore(reduceImpl, defaultValues);
// demo
export { StoreProvider, useStore, useDispatchImpl };
