var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import { useEffect, useRef, useState } from 'react';
import { saveOrderToPay, syncContractState, paymentCommit } from '../../../utils/payment';
import { _ } from '@brushes/tools';
const { get } = _;
export function useOrderResult(code) {
    const [loading, setLoading] = useState(false);
    const channel = useRef('');
    const [channelList, setChannelList] = useState([]);
    const result = useRef({});
    const contract = useRef({
        dataBmoney: '',
        contractBillcode: ''
    });
    useEffect(() => {
        (() => __awaiter(this, void 0, void 0, function* () {
            var _a;
            try {
                const data = yield syncContractState({
                    contractBillcode: code
                });
                contract.current = data.dataObj;
                const res = yield saveOrderToPay({
                    contractBillcode: (_a = contract.current.contractBillcode) !== null && _a !== void 0 ? _a : ''
                });
                setChannelList(res.payChannelList);
                result.current = res;
            }
            catch (err) {
                console.log(err);
            }
        }))();
    }, []);
    const handleRadio = (params) => {
        channel.current = params.detail.value;
    };
    const paymentImpl = () => {
        switch (channel.current) {
            case 'wechatmini':
                wechatmini();
                break;
        }
    };
    const wechatmini = () => __awaiter(this, void 0, void 0, function* () {
        setLoading(true);
        const { ptradeSeqno, contractBlance, payChannelList } = result.current;
        // 模拟微信支付场景
        const pyJsons = [
            {
                faccountIdType: 'ACCOUNT',
                fchannelCode: payChannelList[1].fchannelCode,
                orderAmount: contract.current.dataBmoney,
                faccountId: payChannelList[1].faccountOuterNo || ''
            }
        ];
        try {
            const res = yield paymentCommit({
                ptradeSeqno,
                payCommitStr: JSON.stringify(pyJsons),
                contractBlance
            });
            let data = res.dataObj.requestData;
            wx.requestPayment({
                timeStamp: data.timeStamp,
                nonceStr: data.nonceStr,
                package: data.package,
                signType: data.signType,
                paySign: data.paySign,
                success: function (res) {
                    console.log(64, res);
                },
                fail: function (res) {
                    console.log(res, '失败参数');
                    setLoading(false);
                },
                complete: function (res) {
                    setLoading(false);
                }
            });
        }
        catch (err) {
            setLoading(false);
        }
    });
    return {
        paymentImpl,
        channelList,
        handleRadio,
        contract,
        loading
    };
}
