import { jsx as _jsx, Fragment as _Fragment, jsxs as _jsxs } from "react/jsx-runtime";
import { useComponent, IconMobile } from '@brushes/qj-simulate-component';
import { _ } from '@brushes/tools';
import { useMemo } from 'react';
const { isEmpty } = _;
export const Address = ({ address }) => {
    return _jsx(_Fragment, { children: isEmpty(address) ? _jsx(NoAddress, {}) : _jsx(DefaultAddress, { address: address }) });
};
const DefaultAddress = ({ address }) => {
    const { View, Text } = useComponent();
    const addressInfo = useMemo(() => {
        const { provinceName, addressDefault, cityName, areaName, addressDetail, addressMember = '', addressPhone = '' } = address;
        return {
            addressDefault: addressDefault === '1',
            addressMember,
            addressPhone,
            address: provinceName + cityName + areaName + addressDetail
        };
    }, [address]);
    return (_jsxs(View, Object.assign({ className: "address-info" }, { children: [_jsx(IconMobile, { style: {
                    fontWeight: 900,
                    color: '#444',
                    lineHeight: 3.2
                }, value: 'shouhuodizhi' }), _jsxs(View, Object.assign({ className: "left" }, { children: [_jsxs(View, Object.assign({ className: "left-title" }, { children: [_jsx(Text, { children: addressInfo.addressMember }), _jsx(Text, Object.assign({ className: 'left-padding' }, { children: addressInfo.addressPhone })), _jsx(Text, Object.assign({ className: 'left-padding left-title-default' }, { children: addressInfo.addressDefault ? '默认' : '' }))] })), _jsx(View, Object.assign({ className: "left-detail" }, { children: addressInfo.address }))] })), _jsx(IconMobile, { value: 'xiangyou1', style: {
                    color: '#444',
                    lineHeight: 3,
                    textAlign: 'right'
                } })] })));
};
const NoAddress = () => {
    const { View, Text } = useComponent();
    return (_jsxs(_Fragment, { children: [_jsxs(View, Object.assign({ className: 'group' }, { children: [_jsx(Text, { className: 'local' }), _jsx(Text, Object.assign({ className: 'address' }, { children: "\u9009\u62E9\u6536\u8D27\u5730\u5740" }))] })), _jsx(Text, { className: 'arrow' })] }));
};
