var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import { useEffect, useRef } from 'react';
import { saveOrderToPay, syncContractState, paymentCommit } from '../../../utils/payment';
import { _ } from '@brushes/tools';
const { get } = _;
export function useOrderResult(code) {
    const result = useRef({});
    const amount = useRef(0);
    useEffect(() => {
        (() => __awaiter(this, void 0, void 0, function* () {
            try {
                const data = yield syncContractState({
                    contractBillcode: code
                });
                amount.current = get(data, 'dataObj.dataBmoney', 0);
                const contractBillcode = get(data, 'dataObj.contractBillcode', '');
                result.current = yield saveOrderToPay({
                    contractBillcode
                });
                console.log(result);
            }
            catch (err) {
                console.log(err);
            }
        }))();
    }, []);
    const paymentImpl = () => __awaiter(this, void 0, void 0, function* () {
        const { ptradeSeqno, contractBlance, payChannelList } = result.current;
        // 模拟微信支付场景
        const pyJsons = [
            {
                faccountIdType: 'ACCOUNT',
                fchannelCode: payChannelList[1].fchannelCode,
                orderAmount: amount.current,
                faccountId: payChannelList[1].faccountOuterNo || ''
            }
        ];
        try {
            const res = yield paymentCommit({
                ptradeSeqno,
                payCommitStr: JSON.stringify(pyJsons),
                contractBlance
            });
            console.log(51, res);
            let data = res.dataObj.requestData;
            console.log(data);
            wx.requestPayment({
                timeStamp: data.timeStamp,
                nonceStr: data.nonceStr,
                package: data.package,
                signType: data.signType,
                paySign: data.paySign,
                success: function (res) {
                    console.log(64, res);
                    // http.post(syncContractPayState, {
                    //   contractBillcode: $storage.get('contractBillcode')
                    // })
                    //   .then(res => {
                    //     if (res.success) {
                    //       $router.replace('pay/paySuccess', {
                    //         contractBillcode: $storage.get('contractBillcode')
                    //       });
                    //     } else {
                    //       $router.replace('pay/payFail', {
                    //         contractBillcode: $storage.get('contractBillcode')
                    //       });
                    //     }
                    //   })
                    //   .catch(err => {
                    //     $message.alert('支付失败！');
                    //   });
                },
                fail: function (res) {
                    console.log(res, '失败参数');
                    //$router.replace('pay/payFail')
                },
                complete: function (res) { }
            });
        }
        catch (err) { }
    });
    return {
        paymentImpl
    };
}
