var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import { memo, useEffect, useState } from 'react';
import { navigatorImpl, useComponent, navigatorBackImpl } from '@brushes/qj-simulate-component';
import { SEARCH } from '../../static';
import { useImmutableCallback, _ } from '@brushes/tools';
import { getEnv, getTaro } from '@brushes/api';
import { routerMap } from '../../routerMap';
import { QjMobileIcon } from '../../common/icon';
const flag = getEnv();
const { isEmpty } = _;
const SearchPageJsx = ({ placeholder, placeholderText, history }) => {
    const { View, Text } = useComponent();
    const [historyItem, setHistory] = useState([]);
    useEffect(() => {
        (() => __awaiter(void 0, void 0, void 0, function* () {
            const isTaro = getEnv();
            if (!isTaro)
                return;
            const Taro = yield getTaro();
            const history = Taro.getStorageSync('history') || [];
            setHistory(history);
        }))();
    }, []);
    const searchGoodsImpl = useImmutableCallback((e) => __awaiter(void 0, void 0, void 0, function* () {
        console.log(19, e.detail.value);
        const isTaro = getEnv();
        if (!isTaro)
            return;
        const Taro = yield getTaro();
        setHistory((prevState) => {
            if (isEmpty(e.detail.value))
                return prevState;
            const data = prevState.concat(e.detail.value);
            Taro.getStorageSync('history', data);
            return data;
        });
        navigatorHandler(e.detail.value);
    }));
    const navigatorHandler = useImmutableCallback((value) => {
        navigatorImpl(`${routerMap.goodList}?searchParam=${value}`);
    });
    const removeHistory = () => __awaiter(void 0, void 0, void 0, function* () {
        const Taro = yield getTaro();
        Taro.removeStorageSync('history');
        setHistory([]);
    });
    return (_jsxs(View, Object.assign({ className: 'searchPage', style: { height: flag ? '100vh' : '667px' } }, { children: [_jsxs(View, Object.assign({ className: 'search-title' }, { children: [_jsx("img", { src: SEARCH, alt: "" }), _jsx("input", Object.assign({ "confirm-type": "search", type: "text", className: 'content', onConfirm: searchGoodsImpl }, (placeholder ? { placeholder: placeholderText } : {}))), _jsx(Text, Object.assign({ className: 'btn', onClick: () => navigatorBackImpl() }, { children: "\u53D6\u6D88" }))] })), history ? (_jsxs(View, Object.assign({ className: 'historyWrap' }, { children: [_jsxs(View, Object.assign({ className: 'title' }, { children: [_jsxs(View, Object.assign({ className: 'label' }, { children: [_jsx(View, { className: 'icon' }), "\u5386\u53F2\u641C\u7D22\u8BB0\u5F55"] })), _jsx(QjMobileIcon, { onClick: removeHistory, value: 'shanchu', style: { fontSize: 18, color: '#222', lineHeight: '61px', cursor: 'pointer' } })] })), _jsx(View, Object.assign({ className: 'content' }, { children: historyItem.map((item, index) => {
                            return (_jsx(View, Object.assign({ onClick: () => navigatorHandler(item), className: 'historyItem' }, { children: item }), index));
                        }) }))] }))) : null] })));
};
export const SearchPage = memo(SearchPageJsx);
