var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import { addShoppingGoods, // 再次购买--加入购物车
addShoppingGoodsBySpec, // 检查库存是否足够
queryToContract, // 商品详情页直接下单
getTotalDiscountPrice // 用户权益差价计算
 } from '@brushes/api';
export { updateShoppingGoodsNum, // 更新购物车数量
queryShoppingToContract, // 购物车到订单
saveContract, // 增加订单服务
syncContractState, // 查询订单是否创建成功 (单条)
saveOrderToPay, // 获取支付方式
paymentCommit, // 开始支付
syncContractPayState, // 查看商品是否支付成功
calculateFreightFare, // 计算运费
getFalgSettingForPaydate, //	普通商品查询自动取消订单时间
queryAddressBymerberCode // 获取收货地址
 } from '@brushes/api';
// 规格校验
export const checkSkuSpec = (spec, goodsCode) => __awaiter(void 0, void 0, void 0, function* () {
    const payload = {
        specStr: `[${spec}]`,
        goodsCode
    };
    return yield addShoppingGoodsBySpec(payload);
});
export const addCardSku = (skuId, count) => __awaiter(void 0, void 0, void 0, function* () {
    const payloadNext = {
        skuId,
        goodsNum: count
    };
    // 再次购买--加入购物车
    return yield addShoppingGoods(payloadNext);
});
export const queryToContractImpl = (skuId, goodsNum) => __awaiter(void 0, void 0, void 0, function* () {
    const payloadNext = {
        skuId,
        goodsNum
    };
    // 直接结算页面
    return yield queryToContract(payloadNext);
});
export const getTotalDiscountPriceImpl = (payloadNext) => __awaiter(void 0, void 0, void 0, function* () {
    // const payloadNext = {
    //
    // }
    // 用户权益差价计算
    return yield getTotalDiscountPrice(payloadNext);
});
